// C Source File
// Created 26.12.2003; 22:11:36

#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define SET_FILE_IN_USE_BIT

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

//#define TRICHE
#define RECORD_INIT_ZERO

#include "Sprites.h"
#include "Tableaux.h"
#include "Pingh.h"
#include "Langue.h"

unsigned long scoredep;

void DessChne(short x, short y, const char *chne)	{
	for (;*chne;chne++)		{
		DrawClipChar(x,y,*chne,&(SCR_RECT){{0,0,159,94}},4);
		x+=FontCharWidth(*chne);
	}
}

void gereScrolling(BALLE *s);			//s peut tre nul

void finNiveau ()		{
	int i, j, sousEcran=1;
	car *ecranTemp;
	car str[100];
	short skip=0, att=0;
	long scoreActuel, gain, preGain;

	ecranTemp=malloc(LCD_SIZE);
	if (!ecranTemp)
		sousEcran=0;
	else	{
		memcpy(ecranTemp,ecran,LCD_SIZE);
	}
	PortSet(ecran,239,127);

	while(_keytest(RR_ENTER));

	gain=vies*bonus*300;
	scoreActuel=score;
	preGain=gain;

	for (i=0,j=0;1;)			{
		nvelleFrame(&skip,&att);
		if (i<30)
			i++;
		if (j<100)
			j++;
		if (_keytest(RR_ENTER))
			break;

		if (!skip)		{
			if (sousEcran)
				memcpy(ecran,ecranTemp,LCD_SIZE);
			else
				memset(ecran,0,LCD_SIZE);

			FontSetSys(2);
			niv--;
				sprintf(str,FINI,niv/4+1,niv%4+1);
			niv++;
			DessChne(80-(16*8)/2,i-10,str);
			FontSetSys(1);
			sprintf(str,"Score: %06lu",score);
			DessChne(160-4*i,40,str);
			sprintf(str,"Bonus: %06lu",gain);
			DessChne(160-4*i,48,str);
			sprintf(str,"Total: %06lu",scoreActuel);
			DessChne(160-4*i,56,str);
			sprintf(str,"But  : %06lu",borderLineCourante);
			DessChne((23*i)/6-75,70,str);
			#define UNITE 53
			if (gain-UNITE<0)	{
				scoreActuel+=gain;
				gain=0;
			}
			if (j>=50 && gain>0)		{
				gain-=UNITE;
				scoreActuel+=UNITE;
			}
			Home(ecran);
		}
		frameSkip(&skip,&att);
	}
	score+=preGain;
	if (sousEcran)
		free(ecranTemp);
	return;
}

short EcranTitre (short nivmax, unsigned long record)		{
	int i, dir=1, curs=0, menu=0, k;
	short skip=0, att=0;
	char str[100];

	initGlobales();
	scrlX=scrlY=0;
	baseX=baseY=1;
	PortSet(ecran,239,127);
	ClrScr();
	FontSetSys(0);
	DrawStr(2,95,"Version 1 \xa9 2004 Florian Brnnimann (Brnni)",4);

	i=0;
	while(1)		{
		if (i<25)		i++;
		nvelleFrame(&skip,&att);
		gereScrolling(NULL);
		if (baseY<=1 && scrlY==0 && dir==4)
			dir=1;
		if (baseX>=dimX-10 && scrlX==15 && dir==1)
			dir=2;
		if (baseY>=dimY-12 && scrlY==7 && dir==2)
			dir=3;
		if (baseX<=1 && scrlX==0 && dir==3)
			dir=4;

		if (dir==1)
			scrlX++;
		else if (dir==2)
			scrlY++;
		else if (dir==3)
			scrlX--;
		else if (dir==4)
			scrlY--;

		if (kbhit())
			k=ngetchx();
		else
			k=0;

		if (k==KEY_UP && curs>0)
			curs--;
		if (k==KEY_DOWN && curs<1)
			curs++;
		if (k==KEY_ENTER)		{
			if (curs==1)
				menu=1;
			else
				return 0;
		}

		if (k==KEY_ESC)		{
			if (menu==0)
				return -1;
			else
				menu=0;
		}
		if (k>='1' && k<='1'+nivmax/4 && menu==1)
			return k-'1';

		if (!skip)		{
			memset(ecran,0,95*30);
			afficheTableau();
//			for (i=LCD_SIZE-4;i;i-=4)
//				*(long*)(ecran+i)&=0x55555555;
			FontSetSys(2);
			if (menu==0)	{
				DessChne(80-(8*5)/2,100-3*i,"Balle");
				FontSetSys(1);
				DessChne(-40+4*i,45,DEMARRER);
				DessChne(-40+4*i,53,REPRENDRE);
				DessChne(-50+4*i,45+curs*8,"\32");
//				DrawChar(50,50+curs*8,26,4);
				sprintf(str,"Record: %06lu",record);
				DessChne(80-(14*6)/2-75+3*i,-5+i*3,str);
			}
			else	{
				DessChne(80-(8*14)/2,35,COMMENCERA);
				FontSetSys(1);
				sprintf(str,NIVEAUDISPO,nivmax/4+1);
				DessChne(80-(22*6)/2,50,str);
			}
			CopieEcran(ecran);
		}
		frameSkip(&skip,&att);
	}
}

//Affiche Game Over plus ventuellement une possibilit de continuer.
short GameOver()		{
	int i, j, sousEcran=1;
	car *ecranTemp;
	car chne[10];
	short err, skip=0, att=0;

	ecranTemp=malloc(LCD_SIZE);
	if (!ecranTemp)
		sousEcran=0;
	else	{
		memcpy(ecranTemp,ecran,LCD_SIZE);
	}
	PortSet(ecran,239,127);

	sprintf(chne,"%02i",continues);
	if (continues>0)
		j=45;
	else
		j=55;

	while(_keytest(RR_ESC));

	for (i=0;1;)			{
		nvelleFrame(&skip,&att);
		if (i<j)
			i++;
		if (_keytest(RR_ENTER))		{
			if (continues>0)		{
				continues--;
				err=0;
				break;
			}
			else	{
				err=-1;
				break;
			}
		}
		else if (_keytest(RR_ESC))	{
			err=-1;
			break;
		}

		if (!skip)		{
			if (sousEcran)
				memcpy(ecran,ecranTemp,LCD_SIZE);
			else
				memset(ecran,0,LCD_SIZE);

			FontSetSys(2);
			DessChne(80-(9*8)/2,i-10,PERDU);
			if (continues>0)	{
				FontSetSys(1);
				DessChne(160-(7*i)/3,48,CONTINUER);
				DessChne(-14+2*i,56,chne);
			}
			Home(ecran);
		}
		frameSkip(&skip,&att);
	}
	if (sousEcran)
		free(ecranTemp);
	return err;
}

//Affiche Fin du jeu et ventuellement que ce n'est pas tout  fait le cas si la border line n'a pas t dpasse
void TheEnd(short fini, unsigned long scoremax)		{
	char str[100];

	while(_keytest(RR_ENTER));
	PortRestore();
	ClrScr();
	FontSetSys(2);
	DessChne(80-(6*8)/2,30,LAFIN);
	FontSetSys(0);
	if (fini)		{
		DessChne(10,48,MERCIDAVOIRJOUE);
		DessChne(10,54,PROGRAMMEPARMOI);
	}
	else	{
		sprintf(str,FINIRAVECAUMOINSXPOINTS,scoremax);
		DessChne(10,48,ENFINPASTOUTAFAIT);
		DessChne(10,54,str);
	}
	while(!_keytest(RR_ENTER));
	while(_keytest(RR_ENTER));
}

void gereScrolling(BALLE *s)	{
	if (s)		{
		short balleX=s->x-ecrX;
		short balleY=s->y-ecrY;

		if (!suspendu)	{
			if (balleX<40 && defilX)	{
				scrlX-=40-balleX;
			}
			if (balleX>110 && defilX)	{
				scrlX-=110-balleX;						//110-balleX sera forcment ngatif -> soustraction!
			}
			if (balleY<30 && defilY)	{
				scrlY-=30-balleY;
			}
			if (balleY>65 && defilY)	{
				scrlY-=65-balleY;
			}
		}
	}

	while (scrlX<0)	{
		scrlX+=16;
		baseX--;
	}
	while (scrlX>=16)	{
		scrlX-=16;
		baseX++;
	}
	while (scrlY<0)	{
		scrlY+=8;
		baseY--;
	}
	while (scrlY>=8)	{
		scrlY-=8;
		baseY++;
	}

	if (baseX>=dimX-9 && defilX)		{
		baseX=dimX-10;
		scrlX=15;
	}
	if (baseY>=dimY-11 && defilY)		{
		baseY=dimY-12;
		scrlY=7;
	}
	if (baseX<1 && defilX)		{
		baseX=1;
		scrlX=0;
	}
	if (baseY<1 && defilY)	{
		baseY=1;
		scrlY=0;
	}
}

/*Il y a eu une collision entre la balle et la "caze". Dcidons que faire
  Retourne vrai si on peut passer tout droit sur la case en question avec
  un pouvoir spcial.  */
car gereCaze(unsigned char *caze,BALLE *s)
{
	short fact=s->vitesse;
	if (*caze==2) {
		score+=(100*fact)/2;
		nEl--;
		*caze=0;
		return 0;
	}
	if (*caze==3) {
		*caze=2;
		score+=(100*fact)/2;
		return 0;
	}
	if (*caze==4 && s->vitesse>2) {
		nEl--;
		*caze=0;
		score+=(300*fact)/2;
		return 0;
	}
	else if (*caze==5 && s->pouvoir)	{
		score+=200+100*(fact-2);
		nEl--;
		*caze=0;
		return 1;
	}
	else if (*caze>=16 && *caze<=18) {
		s->valide=0;
	}
	else if (*caze==19 || *caze==20)	{
		score+=50;
		s->tps=59;
	}
	else if (*caze==21 || *caze==22)	{
		score+=100;
		s->tps=119;
	}
	else if (*caze==23)	{
		score+=100;
		*caze=0;
		return 0;
	}
	else if (*caze==32) {
		nPouvoirType=1;
		return 1;
	}
	else if (*caze==33) {
		nMessage=MSG_CREEBALLE;
		//ASSERT ( sizeof (long) == sizeof (BALLE*) )					//Les types doivent tre compatibles!
		msgargs[0]=(long)s;
		return 1;
	}
	return 1;
}


/*Affiche la raquette*/
void afficheRaquette(RAQUETTE *r)
{
	short pos;
	pos=r->pos;
	if (pos-ecrY>92 && (r->mode==1 || r->mode==3))
		ClipSprite8_OR_R(raq-ecrX+4,90,4,fleche,ecran);
	else if (pos-ecrY<0 && (r->mode==1 || r->mode==3))
		ClipSprite8_OR_R(raq-ecrX+4,0,4,fleche+4,ecran);
	else if (pos-ecrX>159 && (r->mode==2 || r->mode==4))
		ClipSprite8_OR_R(156,raqY-ecrY+4,8,flechev,ecran);
	else if (pos-ecrX<0 && (r->mode==2 || r->mode==4))
		ClipSprite8_OR_R(0,raqY-ecrY+4,8,flechev+8,ecran);
	else {
		if (pui>=20 && pui<23)	{
			if (r->mode<=2)
				pos=pos-2*(pui-20);
			else
				pos=pos+2*(pui-20);
		}
		else if (pui>=23)	{
			if (r->mode<=2)
				pos=pos-2*(25-pui);
			else
				pos=pos+2*(25-pui);
		}
		if (r->mode==1) {
			ClipSprite16_OR_R(raq-ecrX,pos-ecrY,7,raquet,ecran);
		}
		else if (r->mode==2) {
			ClipSprite8_OR_R(pos-ecrX,raqY-ecrY,16,raqV,ecran);
		}
		else if (r->mode==3) {
			ClipSprite16_OR_R(raq-ecrX,pos-ecrY,7,raquet,ecran);
		}
		else if (r->mode==4) {
			ClipSprite8_OR_R(pos-ecrX,raqY-ecrY,16,raqV,ecran);
		}
	}
}

/*Gre la raquette et la boule qui rebondit dessus*/
void gereRaquette(BALLE *s, RAQUETTE *r)
{
	int x,y,a;
	int rX;
	int rY;
	int mode=1;

	if (r->mode==1 || r->mode==3) {
		rX=raq;
		rY=r->pos-6;
		y=s->y;

		if (y<rY || y>rY+12)
			return;

		if (y>=rY && y<=rY+6)
			mode=1;
		else if (y>=rY+7 && y<=rY+12)
			mode=3;

		if (mode==1)
			a=s->angle;
		else
			a=_360(s->angle+6);

		if (a<4 || a>9)
			return;

		x=s->x+4;

		if (x<rX-3 || x>rX+18)
			return;

		if (pui>21 && pui<=25){
			s->tps=59;
		}

		if (mode==1)
			s->angle=rebondit(a,x<rX+1,x>rX+14);
		else
			s->angle=_360(rebondit(a,x>rX+13,x<rX+2)-6);
	}
	else {
		rY=raqY;
		rX=r->pos-6;
		x=s->x;
		if (x<rX || x>rX+12)
			return;

		if (x>=rX && x<=rX+6)
			mode=2;
		else if (x>=rX+7 && x<=rX+12)
			mode=4;

		if (mode==2)
			a=_360(s->angle+3);
		else
			a=_360(s->angle-3);

		if (a<4 || a>9)
			return;

		y=s->y+4;

		if (y<rY-3 || y>rY+18)
			return;

		if (pui>21 && pui<=25){
			s->tps=59;
		}
		if (mode==2)
			s->angle=_360(rebondit(a,y>rY+14,y<rY+1)-3);
		else
			s->angle=_360(rebondit(a,y<rY+1,y>rY+14)+3);
	}
}

char tabb[3]={4,1,7};
char tabd[3]={4,1,7};
/*Gere les collisions avec les murs*/
void gereCollisions(BALLE *s)
{
	int dirX=0, dirY=0, a,i,j;
	unsigned char un=1;
	int x,y;
	unsigned char *caze;
	a=s->angle;
	if ((a>=1 && a<=3) || (a>=10 && a<=12))
		dirY=0;
	if (a>=4 && a<=9)
		dirY=8;

	if (a>=1 && a<=6)
		dirX=8;
	if (a>=7 && a<=12)
		dirX=0;
	for (j=0;j<3;j++) {
		i=tabd[j];
		x=(s->x+i);
		y=(s->y+dirY);
		if (x/16<1 || y/8<1 || x/16>dimX)
			caze=&un;
		else
	   caze=&m[x/16][y/8];

		if (*caze) {
			if (gereCaze(caze,s) || !s->pouvoir)	{
				if (a>=1 && a<=6)
					s->angle=7-a;
				else if (a>=7 && a<=12)
					s->angle=19-a;
				a=s->angle;
			}
			break;
		}
	}

	for (j=0;j<3;j++) {
		i=tabb[j];
		x=(s->x+dirX);
		y=(s->y+i);
		if (x/16<1 || y/8<1 || x/16>dimX)
			caze=&un;
		else
			caze=&m[x/16][y/8];

		if (*caze) {
			if (gereCaze(caze,s) || !s->pouvoir)
				s->angle=13-a;
			break;
		}
	}
}

/*Initialise la balle*/
void initBalle(BALLE *s)
{
	s->x=80;
	s->y=8*dimY-16;
	s->angle=11;
	s->cpt=0;
	s->valide=1;
	s->tps=0;
	s->pouvoir=0;
}

unsigned char _2ndEnfonce=0;

/*Gre la touche 'k' en l'associant  la balle du joueur 's'*/
void gereTouches(BALLE *s, int vitesse)
{
	if (_keytest(RR_UP) && raqY>8+vitesse)
		raqY-=2+vitesse;
	if (_keytest(RR_DOWN) && raqY<16*dimY-106-vitesse)
		raqY+=2+vitesse;
	if (_keytest(RR_LEFT) && raq>16+vitesse)
		raq-=2+vitesse;
	if (_keytest(RR_RIGHT) && raq<16*dimX-2-vitesse)
		raq+=2+vitesse;
/*	if (k==KEY_F1 && vitesse>1)
		vitesse--;
	if (k==KEY_F2 && vitesse<9)
		vitesse++;*/
	if (_keytest(RR_2ND) || _keytest(RR_SPACE))		{
		if (pui<=10 && !initial && !_2ndEnfonce)
			pui=25;
		_2ndEnfonce=1;
	}
	else
		_2ndEnfonce=0;

	if (_keytest(RR_SHIFT) && nPouvoirType && nPouvoir==75)
		s->pouvoir=nPouvoirType;
}

/*Procdure principale du jeu*/
short jeu()
{
	int i=0,j, ii;
	int ancienX, ancienY;
	short Pause=0,skip=0,att;
	short nBalles=1, nRaq=4, PauseRequise=0;

	BALLE s[BOULES_MAX];
	RAQUETTE r[RAQS_MAX];


	FILE *f;
	unsigned long param[20];
	if ((f=fopen("*bsauv2*","rb")))		{
		fread(param,sizeof(param),1,f);
		score=param[0];
		vies=param[1];
		niv=param[2];
		min=param[3];
		sec=param[4];
		continues=param[5];
		nBalles=param[6];
		nRaq=param[7];
		initial=param[8];
		nEl=param[9];
		bonus=param[10];
		raq=param[11];
		raqY=param[12];
		nPouvoir=param[13];
		nPouvoirType=param[14];
		scoredep=param[15];
		fread(m,TABLE_X*TABLE_Y,1,f);
		fread(s,sizeof(BALLE)*BOULES_MAX,1,f);
		fread(r,sizeof(RAQUETTE)*RAQS_MAX,1,f);
		fclose(f);
		PauseRequise=1;
		ersteFrame=0;
		SymDel(SYMSTR("*bsauv2*"));
		gereScrolling(&s[0]);
		ecrX=16*baseX+scrlX;
		ecrY=8*baseY+scrlY;
		goto dsjeu;
	}

//nouv_niveau:
perd_vie:
	initial=1;
	r[0].mode=0;
	r[1].mode=0;
	r[2].mode=0;
	r[3].mode=0;
	if (raqs&1) {
		r[0].pos=8*dimY-6;
		r[0].mode=1;
	}
	if (raqs&2) {
		r[1].pos=16*dimX-8;
		r[1].mode=2;
	}
	if (raqs&4) {
		r[2].pos=16;
		r[2].mode=3;
	}
	if (raqs&8) {
		r[3].pos=32;
		r[3].mode=4;
	}
	initBalle(&s[0]);

dsjeu:
	att=0;
	PortSet(ecran,239,127);

	while(1)  {
		nMessage=0;
		nvelleFrame(&skip,&att);
		ecrX=16*baseX+scrlX;
		ecrY=8*baseY+scrlY;

		if (!s[0].valide && nBalles<=1 && initial<=36) {
			trembleEcran();
		}

		if (defil ||ersteFrame)
			gereScrolling(&s[0]);
		ersteFrame=0;

		if (_keytest(RR_BCKSPC) && !initial)		{
			s[0].valide=0;
			nBalles=1;
		}

		if (_keytest(RR_HOME) || _keytest(RR_HAND))		{
sauver:
			if ((f=fopen("*bsauv2*","wb")))		{
				param[0]=score;
				param[1]=vies;
				param[2]=niv;
				param[3]=min;
				param[4]=sec+1;
				param[5]=continues;
				param[6]=nBalles;
				param[7]=nRaq;
				param[8]=initial;
				param[9]=nEl;
				param[10]=bonus;
				param[11]=raq;
				param[12]=raqY;
				param[13]=nPouvoir;
				param[14]=nPouvoirType;
				param[15]=scoredep;
				fwrite(param,sizeof(param),1,f);
				fwrite(m,TABLE_X*TABLE_Y,1,f);
				fwrite(s,sizeof(BALLE)*BOULES_MAX,1,f);
				fwrite(r,sizeof(RAQUETTE)*RAQS_MAX,1,f);
				fclose(f);
				return -2;
			}
		}

		if (!skip) {
			ClrScr();
			afficheTableau();
			afficheScore();
		}

		if (Pause || (!s[0].valide && nBalles<=1))
			goto aff;

		for (ii=0;ii<nBalles;ii++)	{
			if (s[ii].tps>0)	{
				s[ii].tps--;
				s[ii].vitesse=3+s[ii].tps/30;
			}
			else
				s[ii].vitesse=2;

			for (i=0;i<s[ii].vitesse;i++)
			{
				bougeBalle(&s[ii]);
				if (!s[ii].valide)
					break;
				if (!initial) {
					gereCollisions(&s[ii]);
					for (j=0;j<nRaq;j++)
						if (r[j].mode)
							gereRaquette(&s[ii],&r[j]);
				}
			}
			if (ii && !s[ii].valide)	{
				memmove(s+ii,s+ii+1,(nBalles-ii)*sizeof(BALLE));
				nBalles--;
			}
		}

		if (initial) {
			/*Faire tourner la balle (au dbut)*/
			s[0].angle++;
			if (s[0].angle>12)
				s[0].angle-=12;
		}
aff:
		ecrX=16*baseX+scrlX;
		ecrY=8*baseY+scrlY;
#ifdef TRICHE
		if (_keytest(RR_DIAMOND))
			nEl=0;
#endif
		if (_keytest(RR_2ND) || _keytest(RR_SPACE)) {
			if (initial==1 && !m[(s[0].x)>>4][(s[0].y)>>3] && !m[(s[0].x+7)>>4][(s[0].y)>>3] && !m[(s[0].x)>>4][(s[0].y+7)>>3] && !m[(s[0].x+7)>>4][(s[0].y+7)>>3]) {
				pui=20;
				initial=0;
			}
		}

		if (_keytest(RR_ESC))		{
			FontSetSys(2);
			DrawStr(80-(8*8)/2,46,QUITTER,4);
			Home(ecran);
			while(_keytest(RR_ESC));
			while(!_keytest(RR_ESC))		{
				if (_keytest(RR_ENTER))
					return -2;
				idle();
			}
			while(_keytest(RR_ESC));
			RegleTimer(MFS);
		}

		if ((!s[0].valide && nBalles<=1))
		{
			/*Ramener l'cran au point de dpart (perdu une vie)*/
			if (initial<36)
				goto ici;
			ecrX-=ecrX%2;
			ecrY-=ecrY%2;
			if (vies<=1 || ((ecrX<=16 || !defilX) && (ecrY>=8*dimY-90 || !defilY))) break;
			if (ecrX>16 && defilX)
				scrlX-=2;
			if (ecrY<8*dimY-88 && defilY)
				scrlY+=2;
			goto ici;
		}
		if (pui>0) pui--;

		if (!skip) {
			for (i=0;i<nBalles;i++)		{
				if (s[i].valide)
					afficheBalle(&s[i]);
			}
			for (i=0;i<nRaq;i++)
				afficheRaquette(&r[i]);
		}

		ancienX=raq;
		ancienY=raq;

		if (s[0].pouvoir)	{
			if (nPouvoir>=2)		nPouvoir-=2;
			else					s[0].pouvoir=0;
		}
		else	{
			if (nPouvoir<75 && nPouvoirType)		nPouvoir++;
		}

		if (nPouvoirType)	{
			if (nPouvoir>75 || nPouvoir<0)	return 0;			//Erreur grave
			for (i=0;i<5;i++)
				DrawLine(0,i,nPouvoir/2,i,(i==0||i==4)?A_OR:A_REVERSE);
		}

		if (nMessage==MSG_CREERAQUETTEH && nRaq<RAQS_MAX-1)	{
			r[nRaq].pos=msgargs[0];
			r[nRaq].mode=1;
			nRaq++;
		}
		if (nMessage==MSG_CREERAQUETTEV && nRaq<RAQS_MAX-1)	{
			r[nRaq].pos=msgargs[0];
			r[nRaq].mode=2;
			nRaq++;
		}

		if (nMessage==MSG_CREEBALLE && nBalles<BOULES_MAX-1)	{
			memcpy(&s[nBalles],(BALLE*)msgargs[0],sizeof(BALLE));
			if ((s[nBalles].angle-1)%3==2)
				s[nBalles++].angle--;
			else
				s[nBalles++].angle++;
		}

		if (!Pause)
			gereTouches(&s[0],s[0].vitesse);
		if (initial) {
			s[0].x-=ancienX-raq;
		}
ici:
		if (!skip)
			Home(ecran);

		if (_keytest(RR_APPS) || PauseRequise)		{
			FontSetSys(2);
			DrawStr(80-(8*5)/2,46,"PAUSE",4);
			Home(ecran);
			while(_keytest(RR_APPS));
			while(!_keytest(RR_APPS))		{
				idle();
//				Home(ecran);
				if (_keytest(RR_HOME) || _keytest(RR_HAND))
					goto sauver;
			}
			while(_keytest(RR_APPS));
			RegleTimer(MFS);
			PauseRequise=0;
		}


		if (!(sec==59 && min==99*60+59))		{
			ms++;
		}

		if (nEl<=0)	{
			if (nEl<=-1)
				break;
			nEl--;
		}

		frameSkip(&skip,&att);
	}
	if (nEl<=0) {
		if (bonus<12)
			bonus++;
		finNiveau();
		return 1;
	}
	if (vies>1) {
		vies--;
		initGlobales();
		goto perd_vie;
	}
	else return 0;
}

 /*
 Test: Max=3000 sur HW2
 test()
 {
  short i,h;
  char str[100];
  h=20;
  while(h--)  {
   i=0;
   OSFreeTimer(6);
   OSRegisterTimer(6,
   (unsigned long)1);
   while (!OSTimerExpired
   (6)) i++;
  }
  sprintf(str,"%i",i);
  DrawStr(0,0,str,4);
  ngetchx();
 }
 */

short detecteHardware()		{
	const HARDWARE_PARM_BLOCK *hpb = FL_getHardwareParmBlock ();
	if (hpb->len>=24)				//[cite] If len is 24 or more, gateArray contains a hardware version number (currently 1 (HW1) or 2 (HW2)) [/cite]
		return hpb->gateArray;
	else							//[cite] Otherwise, the calculator is certainly a HW1 calculator. [/cite]
		return 1;
}

void _main()
{
	short err;
	short nivmax=0;
	car *arg;
	car niveautermine;
	score=0;
	bonus=0;
	arg=top_estack;
	unsigned long record=0, scoremax;
	FILE *f;
	unsigned long param[20];

	const char *nom;

	if (GetArgType(arg)==STR_TAG)		{
		nom=GetStrnArg(arg);
		if (GetArgType(arg)==POSINT_TAG)
			niv=GetIntArg(arg);
		else
			niv=1;
	}
	else		{
		nom=NULL;
		niv=0;
	}

#ifdef TRICHE
	if (GetArgType(arg)==POSINT_TAG)
		niv=GetIntArg(arg);
	else
		niv=0;
#endif

#ifndef TRICHE
	hw=detecteHardware();

	//En fait cela serait cens tre carrment inutile, mais bon 'faut s'assurer que le timer est  la bonne vitesse
	//Cela dit Cave Blaster (exemple TIGCC) n'est pas l'exemple  suivre tant donn qu'il restaure le timer  la valeur par dfaut du HW1 et ne tient pas compte du HW2 :(
	if (hw==1)
		pokeIO(0x600017,0xB2);
	else if (hw==2)
		pokeIO(0x600017,0xCB);
#endif

	ai1=GetIntVec(AUTO_INT_1);
	ai5=GetIntVec(AUTO_INT_5);
//	ecranHome=malloc(LCD_SIZE);
//	if (!ecranHome)
//		return;
//	LCD_save(ecranHome);
	memset(LCD_MEM,0xff,LCD_SIZE);
	min=sec=ms=0;
	continues=3;
	f=fopen("*bsauve*","rb");
	if (f)	{
		fread(&record,sizeof(record),1,f);
		nivmax=fgetc(f)*4;
		fclose(f);
	}

	scoremax=calcBorderLineTotale(nom,nivmax>=NBRE_NIVEAUX_NORMAUX?NBRE_NIVEAUX_TOTAUX:NBRE_NIVEAUX_NORMAUX);

#ifndef RECORD_INIT_ZERO
	if (scoremax>record)
		record=scoremax;
#endif

	if ((f=fopen("*bsauv2*","rb")))		{
		fread(param,sizeof(param),1,f);
		niv=param[2];
		fclose(f);
	}

	if (niv==0)		{
		niv=1;
		SetIntVec(AUTO_INT_5,IntTimer);
		if (!ouvreFichier(nom,2))
			goto fin;
		niv=EcranTitre(nivmax,record)*4+1;
		if (niv<0)
			goto fin;
		libere();
	}
	borderLineCourante=calcBorderLineTotale(nom,niv);
	niveautermine=0;

refait:
	SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
	SetIntVec(AUTO_INT_5,IntTimer);
	if (niv-1>nivmax)
		nivmax=niv-1;
	scoredep=score;
	editeur=0;
	if (!ouvreFichier(nom,niv))
		goto fin;
	if (niveautermine)
		borderLineCourante+=calcBorderLine();
	niveautermine=0;
	initGlobales();
	vies=3;
	err=jeu();

	if (err==-2)			//Quitte
		goto fin;

	if (err==1)		{				//Niveau termin
		if (niv==NBRE_NIVEAUX_NORMAUX)	{
			if (score>=scoremax || nivmax>=NBRE_NIVEAUX_NORMAUX)
				niv++;
			else	{
				TheEnd(0,scoremax);
				niv=32;
				goto fin;
			}
		}
		else if (niv==NBRE_NIVEAUX_TOTAUX)	{
			TheEnd(1,scoremax);
			goto fin;
		}
		else
			niv++;
		continues++;
		niveautermine=1;
	}
	else	{
		err=GameOver();
		bonus/=2;
		if (err>=0)
			score=scoredep;
	}

	if (err>=0)
		goto refait;

	PortRestore();
	libere();
fin:
	PortRestore();
	libere();
	if (score>record)
		record=score;
//	LCD_restore(ecranHome);
//	free(ecranHome);
	SetIntVec(AUTO_INT_1,ai1);
	SetIntVec(AUTO_INT_5,ai5);
	EM_moveSymFromExtMem(SYMSTR("*bsauve*"),HS_NULL);
	f=fopen("*bsauve*","wb");
	fwrite(&record,sizeof(record),1,f);
	fputc(nivmax/4,f);
	fclose(f);
	EM_moveSymToExtMem(SYMSTR("*bsauve*"),HS_NULL);

	GKeyFlush();

//	OSInitKeyInitDelay(220);
//	OSInitBetweenKeyDelay(30);
	return;
}
