// C Source File
// Created 28.12.2003; 22:45:27

#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

#include "Sprites.h"
#include "Pingh.h"

void entree(short x, short y, char *str, int *derTouche)
{
	short i,k;
	i=0;
	while (i<10) {
		memcpy(LCD_MEM,ecran,LCD_SIZE);
		DrawStr(x,y,str,4);
		k=ngetchx();
		if (k>='0' && k<='9')
			str[i++]=k;
		else if (k==257 && i>0)
			i--;
		else break;
		str[i]=0;
	}
	str[i]=0;
	if (i==0) {
		str[i]='0';
		str[i+1]=0;
	}
	*derTouche=k;
}

/* short atoi(chn)
 unsigned char *chn;
 {
  short n,i;
  unsigned char *deb;
  deb=chn;
  while(*(++chn));
  chn--;
  i=1;
  n=0;
  while(chn>=deb) {
   n+=(*(chn)-48)*i;
   i*=10;
   chn--;
  }
  return n;
 }*/

void jeu()
{
	int k,i;
	int x,y;
	char str[100];
	baseX=1;
	baseY=1;
	x=y=0;
	suspendu=1;

	while(1)
	{
		if (!defil) {
			baseX=1;
			baseY=1;
		}
		PortSet(ecran,239,127);
		scrlX=scrlY=0;
		ClrScr();
		afficheTableau();
		Sprite16(16*x,8*y,8,rectgle,ecran,SPRT_XOR);
		memcpy(LCD_MEM,ecran,LCD_SIZE);
		PortRestore();
		if (!defil)
			baseX=baseY=1;
		k=ngetchx();
		if (k==49) {
			sprintf(str,"%i",m[baseX+x][baseY+y]);
			entree(0,93,str,&k);
			m[baseX+x][baseY+y]=atoi(str);
		}
		if (k==337) y--;
		if (k==338) x--;
		if (k==340) y++;
		if (k==344) x++;
		if (k==ESC)
			break;
		while (x<0) {
			x++;
			baseX--;
		}
		while (y<0) {
			y++;
			baseY--;
		}
		while (x>9) {
			x--;
			baseX++;
		}
		while (y>11) {
			y--;
			baseY++;
		}
		if (!defil) goto nscrl;
		while(baseX>dimX-9)
			baseX--;
		while(baseY>dimY-11)
			baseY--;
		while(baseX<=0)
			baseX++;
		while(baseY<=0)
			baseY++;
nscrl:
	;
	}
}

int _main()
{
	int a,b, maxY, z,zz, i,j;
	char c, multiNiveau;
	int nCol,n, Niveau;
	car str[100];
	car screen[3840];
	car *ptr;
	FILE *f=NULL, *F=NULL;
	const char *nom, *sym_nom;
	unsigned char (*m9)[TABLE_Y] = NULL;

	ESI argptr=top_estack;

	memcpy(screen,LCD_MEM,LCD_SIZE);
	OSInitBetweenKeyDelay(30);
	OSInitKeyInitDelay(150);

	if (GetArgType(argptr)==STR_TAG)	{
		nom=GetStrnArg(argptr);
	}
	else
		return 0;

	if (GetArgType(argptr)==31)
		Niveau=GetIntArg(argptr);
	else
		Niveau=1;

	if (!ouvreFichier(nom,Niveau)) {
		if (!alloc())
			goto frie;
		for (b=0;b<dimY;b++)
			for (a=0;a<dimX;a++)
				m[a+1][b+1]=1;
	}
	initGlobales();
	jeu();
	PortRestore();
	memcpy(LCD_MEM,screen,LCD_SIZE);
	OSInitKeyInitDelay(220);
	OSInitBetweenKeyDelay(30);
	if (DlgMessage("Attention","Enregister les modifications?",BT_YES,BT_NO)==264)
		goto frie;

	push_zstr (nom);
	argptr=top_estack;
	sym_nom=GetSymstrArg(argptr);							//symstr pour la gestion du fichier

	EM_moveSymToExtMem (sym_nom, HS_NULL);		//Archive #nom pour gagner de la place

	editeur=1;
	f=fopen(nom,"r");
	multiNiveau=0;
	while(!feof(f))
		if (fgetc(f)==16)						multiNiveau++;
	fclose(f);

	if (multiNiveau)	{														//D'abord crire tout jusqu'au niveau courant
		F=fopen(nom,"rt");
		if (!(f=fopen("temp","wt")))	{									//Peut pas l'ouvrir
			Erreur("Fichier temp inaccessible!");
			goto frie;
		}
		for (a=1;a<=Niveau;a++)	{
			while (1)		{
				c=fgetc(F);
				if (a!=Niveau)			{								//Pas crire le niveau courant. On crira la version modifie ensuite
					if (fputc(c,f)==EOF)	{
						Erreur("Mmoire\12fputc(c,f)==EOF");
						goto frie;
					}
				}
				if (c==16)			break;
				if (c==EOF)			break;
			}
		}
	}
	else	{																				//Pas de multi-niveau
		if (!(f=fopen("temp","wt")))	{									//Peut pas l'ouvrir
			Erreur("Fichier temp inaccessible!");
			goto frie;
		}
	}

	fputc(dimX+32,f);
	fputc(dimY+32,f);
	fputc(raqs+32,f);
	fputc(fond==0?32:33,f);
//	fputc('\r',f);															//Sparateur de section

	maxY=TABLE_Y-1;

	for (c=1;c<=1;c++)	{
		if (c==1)
			m9=m;
/*		else if (c==2)
			m9=m2;
		else if (c==3)
			m9=m3;*/

		maxY=0;
		for (b=0;b<TABLE_Y-1;b++)	{
			for (a=0;a<TABLE_X;a++)	{
				if (m9[a][b])
					maxY=b;
			}
		}
		//Nombre max de lignes trouv
		for (b=1;b<=maxY;b++)	{
			fputc(13,f);
			zz=0;
			for (z=1;z<TABLE_X;z++)	{
				if (m9[z][b])
					zz=z+1;
			}
			//Nombre max de colonnes trouv
			for (a=1;a<zz;a++)	{
				j=m9[a][b];
				i=0;
				while (m9[a+i][b]==j && a+i<zz-1) i++;
				i--;
				//Utilisation de la compression
				if (i>=2 && j==0)	{
					fputc(18,f);								//C'est une suite de zros
					fputc(32+i,f);							//Nombre de zros contigus
					a+=i+1;
				}
				if (i>=3 && j!=0)	{
					fputc(17,f);								//C'est une suite de motifs identiques
					fputc(j+32,f);							//Quel est ce motif
					fputc(32+i,f);							//Le nombre de fois qu'il se rpte
					a+=i+1;
				}
				if (fputc(m9[a][b]+32,f)==EOF)	{
					Erreur("Mmoire\12fputc(m9[a][b]+32,f)==EOF");
					goto frie;
				}
			}
		}
		if (c<3)
			fputc(22,f);
	}

	if (multiNiveau && !feof(F))	{
		fputc(13,f);
		fputc(16,f);
		while(!feof(F))	{
			if (fputc(fgetc(F),f)==EOF)	{
				Erreur("Mmoire\12fputc(fgetc(F),f)==EOF");
				goto frie;
			}
		}
		fclose(F);
	}
 	fclose(f);

	TRY
		EM_moveSymToExtMem ($(temp), HS_NULL);					//Archive temp
		EM_moveSymFromExtMem (sym_nom, HS_NULL);				//Unarchiv #nom
 		cmd_copyvar($(temp),sym_nom);										//CopyVar temp,#nom
		EM_moveSymToExtMem (sym_nom, HS_NULL);					//Archive #nom
		EM_moveSymFromExtMem ($(temp), HS_NULL);				//Unarchiv temp
		SymDel($(temp));
 	ONERR
 		Erreur("Copie temp -> #nom chou!");
 	ENDTRY

frie:
	libere();
	return 0;
}
